// blink.c
//
// Example program for bcm2835 library
// Blinks a pin on an off every 0.5 secs
//
// After installing bcm2835, you can build this 
// with something like:
// gcc -o blink blink.c -l bcm2835
// sudo ./blink
//
// Or you can test it before installing with:
// gcc -o blink -I ../../src ../../src/bcm2835.c blink.c
// sudo ./blink
//
// Author: Mike McCauley
// Copyright (C) 2011 Mike McCauley
// $Id: RF22.h,v 1.21 2012/05/30 01:51:25 mikem Exp $
#include <bcm2835.h>
#include <stdio.h>
// Blinks on RPi Plug P1 pin 11 (which is GPIO pin 17)
int port[] = {2,3,4,17,27,22,10,9,11,0,5,6,12,13,19,26,14,15,18,23,24,25,8,7,1,12,16,20,21};
int main(int argc, char **argv)
{
    // If you call this, it will not actually access the GPIO
    // Use for testing
//    bcm2835_set_debug(1);
    if (!bcm2835_init())
      return 1;
    // Set the pin to be an output
    for(int i = 0; i<sizeof(port); i++)
    {
        bcm2835_gpio_fsel(port[i], BCM2835_GPIO_FSEL_OUTP);
    }
    // Blink
    while (1)
    {
        // Turn it on
	for(int i = 0; i<sizeof(port); i++)
	{
            bcm2835_gpio_write(port[i], HIGH);
	}
        // wait a bit
        bcm2835_delay(500);
        
        // turn it off
	for(int i = 0; i<sizeof(port); i++)
	{
            bcm2835_gpio_write(port[i], LOW);
	}
        
        // wait a bit
        bcm2835_delay(500);
    }
    bcm2835_close();
    return 0;
}
